

from tkinter import *
HEIGHT = 500
WIDTH = 800
window = Tk()
window.title('Подводная лодка и шары')
c = Canvas (window, width=WIDTH, height=HEIGHT, bg='darkblue')
c.pack()
ship_id1 = c.create_oval( 50, 10, 150, 60,  fill='red')
ship_id2 = c.create_oval( 100, 20, 130, 50, fill='black')
ship_id3 = c.create_polygon( 100, 10, 100, 60, 0, 35, fill='red')
ship_id4 = c.create_rectangle( 90, 8, 110, 12, fill='black')
ship_id5 = c.create_rectangle( 0, 20, 0, 50, fill='black')
SHIP_R = 15
BOMB_R = 10
MID_X = WIDTH / 2
MID_Y = HEIGHT / 2
c.move(ship_id1, MID_X, MID_Y)
c.move(ship_id2, MID_X, MID_Y)
c.move(ship_id3, MID_X, MID_Y)
c.move(ship_id4, MID_X, MID_Y)
c.move(ship_id5, MID_X, MID_Y)
SHIP_SPD = 20
def move_ship(event):
    if event.keysym == 'Up':
        c.move(ship_id1, 0, -SHIP_SPD)
        c.move(ship_id2, 0, -SHIP_SPD)
        c.move(ship_id3, 0, -SHIP_SPD)
        c.move(ship_id4, 0, -SHIP_SPD)
        c.move(ship_id5, 0, -SHIP_SPD)
    elif event.keysym == 'Down':
        c.move(ship_id1, 0, SHIP_SPD)
        c.move(ship_id2, 0, SHIP_SPD)
        c.move(ship_id3, 0, SHIP_SPD)
        c.move(ship_id4, 0, SHIP_SPD)
        c.move(ship_id5, 0, SHIP_SPD)
    elif event.keysym == 'Left':
        c.move(ship_id1, -SHIP_SPD, 0)
        c.move(ship_id2, -SHIP_SPD, 0)
        c.move(ship_id3, -SHIP_SPD, 0)
        c.move(ship_id4, -SHIP_SPD, 0)
        c.move(ship_id5, -SHIP_SPD, 0)
    elif event.keysym == 'Right':
        c.move(ship_id1, SHIP_SPD, 0)
        c.move(ship_id2, SHIP_SPD, 0)
        c.move(ship_id3, SHIP_SPD, 0)
        c.move(ship_id4, SHIP_SPD, 0)
        c.move(ship_id5, SHIP_SPD, 0)
c.bind_all('<Key>',move_ship)
from random import randint
bub_id = list()
bub_r = list()
bub_speed = list()
bomb_id = list()
MAX_BOMB_SPD = 5
bomb_speed = list()
MIN_BUB_R = 10
MAX_BUB_R = 30
MAX_BUB_SPD = 10
GAP = 100
def create_bubble():
    x = WIDTH+GAP
    y = randint(0, HEIGHT)
    r = randint(MIN_BUB_R, MAX_BUB_R)
    id1 = c.create_oval(x - r, y - r, x + r, y + r, outline='white')
    bub_id.append(id1)
    bub_r.append(r)
    bub_speed.append(randint(1, MAX_BUB_SPD))
def create_bomba():
    y = -HEIGHT -GAP
    x = randint(0,WIDTH )
    r = 30
    id1 = c.create_oval(x - 30, y - 30, x + 30, y + 30, fill='red')
    bomb_id.append(id1)
    bomb_speed.append(randint(1, MAX_BUB_SPD))
def move_bomba():
    for i in range(len(bomb_id)):
        c. move (bomb_id[i],0, bomb_speed[i])
def move_bubbles():
    for i in range(len(bub_id)):
        c.move(bub_id[i], -bub_speed[i], 0)
def get_coords(id_num):
    pos = c.coords(id_num)
    x = (pos[0] + pos[2])/2
    y = (pos[1] + pos[3])/2
    return x,y
def del_bubble(i):
    del bub_r[i]
    del bub_speed[i]
    c.delete(bub_id[i])
    del bub_id[i]
def clean_up_bubs():
    for i in range(len(bub_id)-1, -1, -1):
        x, y = get_coords(bub_id[i])
        if x < -GAP:
            del_bubble(i)
def del_bomb(i):
    del bomb_speed[i]
    c.delete(bomb_id[i])
    del bomb_id[i]            
def clean_up_bomb():
    for i in range(len(bomb_id)-1, -1, -1):
        x, y = get_coords(bomb_id[i])
        if y > HEIGHT + GAP:
            del_bomb(i)
from math import sqrt
def distance(id1, id2):
    x1, y1 = get_coords(id1)
    x2, y2 = get_coords(id2)
    return sqrt((x2 - x1)**2 + (y2 - y1)**2)
def collision():
    points = 0
    for bub in range(len(bub_id)-1, -1, -1):
        if distance(ship_id1, bub_id[bub]) < (SHIP_R + bub_r[bub]):
            points +=(bub_r[bub] + bub_speed[bub])
            del_bubble(bub)
    return points
def collision1():
    points = 0
    for bomb in range(len(bomb_id)-1, -1, -1):
        if distance(ship_id1, bomb_id[bomb]) < (SHIP_R + BOMB_R):
            points +=(BOMB_R + bomb_speed[bomb])
            del_bomb(bomb)
    return points

c.create_text(50, 30, text='Время', fill='white')
c.create_text(150, 30, text='Очки', fill='white')
time_text = c.create_text(50, 50,  fill='white')
score_text = c.create_text(150, 50,  fill='white')
def show_score(score):
    c.itemconfig(score_text, text=str(score))
def show_time(time_left):
    c.itemconfig(time_text,text=str(time_left)) 
    

from time import sleep, time
BUB_CHANGE = 10
BOMB_CHANGE = 70
TIME_LIMIT = 30
BONUS_SCORE = 1000
score = 0
bonus = 0
end = time() + TIME_LIMIT 
#MAIN GAME LOOP
while time () < end:
   if randint(1, BOMB_CHANGE) == 1:
        create_bomba()  
   move_bomba() 
   if randint(1, BUB_CHANGE) == 1:
        create_bubble()
      
   move_bubbles()
   
   clean_up_bubs()
   clean_up_bomb()  
   score += collision()
   score -= collision1() 
  
   if (int(score /BONUS_SCORE)) > bonus:
       bonus += 1
       end += TIME_LIMIT
   show_score(score)
   show_time (int(end - time()))       
   
   window.update()
   sleep(0.01)
c.create_text(MID_X, MID_Y, \
    text='Конец игры', fill='white', font=('Helvetica', 30))
c.create_text(MID_X, MID_Y + 30, \
    text='Очки: '+ str(score), fill='white')
c.create_text(MID_X, MID_Y +45, \
    text='Дополнительное время: '+ str(bonus*TIME_LIMIT), fill='white')
